<?php

namespace FwMigrationSystem\User;

use FwMigrationSystem\Main\Migratable;
use FwMigrationSystem\Main\Migration;
use FwMigrationSystem\Resources\Blueprint;
use FwMigrationSystem\Resources\TableName;

class ReservationsMigration extends Migratable {
    const modelName = 'Reservations';

    public function create_table() {
        return Migration::Create(new TableName(self::modelName), function (Blueprint $blueprint) {
            $blueprint->primary_key('reservation_id');
			$blueprint->Int('user_id')->Len(150);
			$blueprint->Int('ad_id')->Len(150);
			$blueprint->Int('ad_time_id')->Len(150);
			$blueprint->Int('reservation_status')->Len(150);
			$blueprint->Text('reservation_status_details');
			$blueprint->Datetime('created_at')->Default('CURRENT_TIMESTAMP()');

             return $blueprint;
        });
    }

    public function drop_table() {
        return Migration::DropIfExists(new TableName(self::modelName));
    }
}
