<?php

namespace FwMigrationSystem\User;

use FwMigrationSystem\Main\Migratable;
use FwMigrationSystem\Main\Migration;
use FwMigrationSystem\Resources\Blueprint;
use FwMigrationSystem\Resources\TableName;

class PostsMigration extends Migratable {
    const modelName = 'Posts';

    public function create_table() {
        return Migration::Create(new TableName(self::modelName), function (Blueprint $blueprint) {
            $blueprint->primary_key('post_id');
			$blueprint->VarChar('blog_post_title')->Len(150);
			$blueprint->VarChar('blog_post_cover')->Len(150);
			$blueprint->Int('tag_id')->Len(150);
			$blueprint->Int('category_id')->Len(150);
			$blueprint->Text('post_content');
			$blueprint->VarChar('post_video')->Len(150);
			$blueprint->VarChar('post_audio')->Len(150);
			$blueprint->Datetime('created_at')->Default('CURRENT_TIMESTAMP()');

             return $blueprint;
        });
    }

    public function drop_table() {
        return Migration::DropIfExists(new TableName(self::modelName));
    }
}
