<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Headers: *");
header("Access-Control-Allow-Methods: GET, OPTIONS, POST");

use DATABASE\ORM\QueryBuilder\QueryBuilder\Db;
use FwRoutingSystem\Router;

//ini_set('session.save_path', '/tmp');
ini_set('error_reporting', E_ALL);
ini_set('display_errors', E_ALL);
include '../admin/src/autoload.php';
const __API__ = __DIR__ . '/routes/';
define("__HOST__", "https://api." . str(FwConfig::HOST())->explode('/')[0]);
const __IMAGES__ = 'https://nahid.lexaplus.com/admin/src/images/';
const __FILES__ = __IMAGES__ . 'Files/';
$Router = new Router();
Db::table('tblApiRequests')->insert([
	'ip'      => getIp(),
	'route'   => $_SERVER['REQUEST_URI'],
	'headers' => json_encode(getallheaders()),
]);
$Router->get('/qrcode', function () {
	include 'qrcode.php';
});
header('Content-Type: application/json');
const global_error = "Unknown error!";
http_response_code(500);

function response($content, $statusCode = 200) {
	http_response_code($statusCode);
	return is_iterable($content) ? json_encode($content, JSON_UNESCAPED_UNICODE) : $content;
}

$Router->any('/callback/fail', function () {
	header('Content-Type: text/html');
	include 'callback-fail.php';
});
$Router->any('/callback/success', function () {
	header('Content-Type: text/html');
	include 'callback-success.php';
});
$Router->any('/', function () {
	return response([], 404);
});
$Router->any('/main/index', function () {
	return response([], 404);
});



$Router->error(function () {
	echo response(['message' => 'endpoint not found'], 404);
});
$Router->any(':all/:all?/:all?/:all?/:all?/:all?', function () {
	return response(['message' => 'endpoint not found'], 404);
});
